  // 组件列表
import ko from 'knockout'
const ID = 'yy-cooperation-resource-id'
// 引入协同云附件
window.creatCoopUrl = function () {
  // 如果已经加载过协同附件则不重复加载
  if (window.YYCooperationBridge) {
    return
  }
  // 如果相关资源已经加载过也不加载
  var el = document.getElementById(ID)
  if (el) {
    return
  }
  var host = window.location.host
  var resourceAddress = '/iuap-apcom-file/ucf-wh/fileservice/web/fileservice-web.min.js'
  var s = document.createElement("script");
  s.id = ID
  s.src = resourceAddress
  document.head.appendChild(s);
}
// 注册普通组件
ko.components.register(process.env.FILE_TAG_NAME || 'u-fileupload', {
  viewModel: require('./u-fileupload/index').default,
  // template: { fromUrl: name},
  template: require('./u-fileupload/index.html')
})
// 注册普通组件
ko.components.register(process.env.FILE_TAG_NAME_INTABLE || 'u-fileupload-intable', {
  viewModel: require('./u-fileupload/index').default,
  // template: { fromUrl: name},
  template: require('./u-fileupload/fileintable.html')
})
// 注册替换组件
ko.components.register(process.env.FILE_TAG_NAME_REPLACE || 'u-fileupload-replace', {
  viewModel: require('./u-fileupload/index').default,
  template: require('./u-fileupload/replace.html')
})
ko.components.register(process.env.FILE_TAG_NAME_INTABLE_READONLY || 'u-fileupload-intable-readonly', {
  viewModel: require('./u-fileupload/linereadonly').default,
  template: require('./u-fileupload/linereadonly.html')
}) 
ko.components.register('ko-imgupload', {
  viewModel: require('./u-fileupload/index').default,
  // template: { fromUrl: name},
  template: require('./u-fileupload/imgdisplay.html')
})
ko.components.register('y-upload', {
  viewModel: require('./u-fileupload/index').default,
  // template: { fromUrl: name},
  template: require('./u-fileupload/yupload.html')
})
ko.components.register('y-upload-read', {
  viewModel: require('./u-fileupload/index').default,
  // template: { fromUrl: name},
  template: require('./u-fileupload/yuploadread.html')
})

ko.components.register('coop-upload', {
  viewModel: require('./coop-fileupload/index').default,
  // template: { fromUrl: name},
  template: require('./coop-fileupload/index.html')
})
ko.components.register('coop-upload-intable', {
  viewModel: require('./coop-fileupload/fileintable.js').default,
  // template: { fromUrl: name},
  template: require('./coop-fileupload/fileintable.html')
})